/*
###############################################################################
# Copyright (c) 2017, PulseRain Technology LLC 
#
# This program is distributed under a dual license: an open source license, 
# and a commercial license. 
# 
# The open source license under which this program is distributed is the 
# GNU Public License version 3 (GPLv3).
#
# And for those who want to use this program in ways that are incompatible
# with the GPLv3, PulseRain Technology LLC offers commercial license instead.
# Please contact PulseRain Technology LLC (www.pulserain.com) for more detail.
#
###############################################################################
*/


//=============================================================================
// Remarks:
//    Wishbone wrapper for encoder
//=============================================================================

`include "config.vh"
`include "common.vh"


`default_nettype none

module wb_encoder 
					  #(parameter
					     REG_ADDR_DATA
                      )
		(

        
        //=======================================================================
        // clock / reset
        //=======================================================================
        
        input   wire                                clk,
        input   wire                                reset_n,

        //=======================================================================
        // Wishbone Interface (FASM synchronous RAM dual port model)
        //=======================================================================                  
		
    	output wire  unsigned [31 : 0]                     dat_o,
    
        //=======================================================================
        // encoder output
        //=======================================================================
		 input  wire 								       encoder_A1,
		 input  wire 								       encoder_A2,
	    input  wire 								       encoder_B1,
       input  wire 								       encoder_B2
		 
		 
);


    
    
    //=======================================================================
    // Signals 
    //=======================================================================
        
    
	      wire  unsigned [15 : 0]                    counter_A;  
	      wire  unsigned [15 : 0]                    counter_B;
		   wire  unsigned [31 : 0]                    counter_encoder;
         
       //  wire  unsigned [31 : 0]                    counter_encoder1;
		 //assign	counter_encoder1 = 32'd12;
			
			

		 assign counter_encoder =  {counter_B,counter_A};      //counter_encoder1;  
		 assign dat_o = counter_encoder;
		
              
                
        encoder_core  encoder_core (
				   .clk(clk),
               .reset_n(reset_n), 
					.encoder_L_A(encoder_A1),
					.encoder_L_B(encoder_A2),
					.encoder_R_A(encoder_B1),
					.encoder_R_B(encoder_B2),
               .counter_L(counter_A),
					.counter_R(counter_B)
                );
                
       

endmodule : wb_encoder


`default_nettype wire
